#include <bits/stdc++.h>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;

    cin>>t;
    int n,k;
    cin>>n>>k;
    bool s1=true;
    bool s2=true;
    bool s3=true;
    vector<int>v(n);
     cin>>v[0];
     if(v[0]>1 & v[0]<-1){
        s2=false;
     }
     if(v[0]!=1){
        s1=false;
     }
    for(int i=1;i<n;i++){
       cin>>v[i];
       if(v[i-1]!=v[i]){
        s3=false;
       }
        if(v[i]>1 & v[i]<-1){
        s2=false;
     }
     if(v[i]!=i+1){
        s1=false;
     }



}
int kp=0;
if(s1==true){
    if(n%2==0 & k%2==0){
        cout<<"DA"<<endl;
    }
    else{
        cout<<"NE"<<endl;
    }
}
else if(s3==true){
    for(int i=0;i<n;i++){
            cout<<i<<endl;
        if(kp<=v[i]){
            kp++;
        }
        else{
            kp--;
        }
    }
    if(kp==k){
        cout<<"DA"<<endl;
        if(t==1){
        for(int i=0;i<n;i++){
            cout<<v[i]+" ";
        }}
    }
    else{cout<<"NE"<<endl;}

}

}